<?php

namespace Drupal\entity_template_ui\PluginForm;

use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Plugin\ContextAwarePluginAssignmentTrait;
use Drupal\Core\Plugin\PluginFormBase;
use Drupal\Core\StringTranslation\StringTranslationTrait;

/**
 * Component plugin form for context aware components.
 *
 * @package Drupal\entity_template_ui\PluginForm
 */
class ContextAwareComponentForm extends PluginFormBase {
  use ContextAwarePluginAssignmentTrait;
  use StringTranslationTrait;

  /**
   * {@inheritdoc}
   */
  public function buildConfigurationForm(array $form, FormStateInterface $form_state) {
    $contexts = $form_state->getTemporaryValue('gathered_contexts') ?: [];
    $form['context_mapping'] = $this->addContextAssignmentElement($this->plugin, $contexts);
    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function submitConfigurationForm(array &$form, FormStateInterface $form_state) {
    $configuration = $this->plugin->getConfiguration();
    $configuration['context_mapping'] = $form_state->getValue(['context_mapping']);
    $this->plugin->setConfiguration($configuration);
  }
}
