<?php

namespace Drupal\entity_template;

use Drupal\Core\Session\AccountInterface;
use Drupal\Core\Url;
use Drupal\entity_template\Entity\BlueprintEntityInterface;
use Drupal\entity_template\Entity\TemplateBlueprint;
use Drupal\entity_template\Plugin\EntityTemplate\BlueprintProvider\BlueprintProviderInterface;

class BlueprintEntityStorageAdaptor extends BlueprintEntityAdaptor implements BlueprintStorageInterface {
  use BlueprintStorageTrait;


  /**
   * BlueprintEntityStorageAdaptor constructor.
   *
   * @param \Drupal\entity_template\Entity\BlueprintEntityInterface $entity
   * @param \Drupal\entity_template\Plugin\EntityTemplate\BlueprintProvider\BlueprintProviderInterface $provider
   */
  public function __construct(
    BlueprintEntityInterface $entity,
    BlueprintProviderInterface $provider
  ) {
    parent::__construct($entity);
    $this->provider = $provider;
  }

  /**
   * {@inheritdoc}
   */
  public function access($operation, AccountInterface $account, $return_as_object = TRUE) {
    return $this->getEntity()->access($operation, $account, $return_as_object);
  }

}
