<?php

namespace Drupal\entity_template\Exception;

use Throwable;

class MultipleAvailableBlueprintException extends BuilderException {

  /**
   * @var \Drupal\entity_template\BlueprintInterface[]
   */
  protected $blueprints;

  /**
   * MultipleAvailableBlueprintException constructor.
   *
   * @param string $message
   * @param array $blueprints
   * @param int $code
   * @param \Throwable|NULL $previous
   */
  public function __construct(string $message = "", array $blueprints = [], int $code = 0, Throwable $previous = NULL) {
    parent::__construct($message, $code, $previous);

    $this->blueprints = $blueprints;
  }

  /**
   * The blueprints available.
   *
   * @return array|\Drupal\entity_template\BlueprintInterface[]
   */
  public function getBlueprints() {
    return $this->blueprints;
  }

}
