<?php

namespace Drupal\entity_template;

use Drupal\Core\Entity\EntityInterface;

class MultipleTemplateResult extends TemplateResult {

  /**
   * @var \Drupal\Core\Entity\EntityInterface[]
   */
  protected $entities = [];

  /**
   * {@inheritdoc}
   */
  public function setEntity(EntityInterface $entity) {
    $this->entities[] = $entity;
  }

  /**
   * {@inheritdoc}
   */
  public function getEntity(): \Drupal\Core\Entity\EntityInterface {
    return reset($this->entities);
  }

  /**
   * Add an entity to the result.
   *
   * @param $key
   * @param \Drupal\Core\Entity\EntityInterface $entity
   *
   * @return static
   */
  public function addEntity($key, EntityInterface $entity) {
    $this->entities[$key] = $entity;
    return $this;
  }

  /**
   * Get the entities
   *
   * @return \Drupal\Core\Entity\EntityInterface[]
   */
  public function getEntities() {
    return $this->entities;
  }

}
