<?php

namespace Drupal\entity_template\Plugin\EntityTemplate\Builder;

use Drupal\entity_template\Entity\TemplateBlueprint;

/**
 * Interface for builders that have a configurable default blueprint.
 *
 * @package Drupal\entity_template\Plugin\EntityTemplate\Builder
 */
interface ConfigurableDefaultBlueprintInterface {

  /**
   * Get the default blueprint config.
   *
   * @return \Drupal\entity_template\Entity\TemplateBlueprint
   *   The default blueprint entity.
   *
   * @throws \Drupal\Component\Plugin\Exception\InvalidPluginDefinitionException
   * @throws \Drupal\Component\Plugin\Exception\PluginNotFoundException
   */
  public function getDefaultBlueprintConfig() : TemplateBlueprint;

}
