<?php

namespace Drupal\entity_template\Plugin\EntityTemplate\Component;

use Drupal\entity_template\Plugin\EntityTemplate\Template\TemplateInterface;

trait TemplateContextAwareComponentTrait {

  /**
   * @var TemplateInterface
   */
  protected $template;

  /**
   * Set the template.
   *
   * @param \Drupal\entity_template\Plugin\EntityTemplate\Template\TemplateInterface $template
   *
   * @return static
   */
  public function setTemplate(TemplateInterface $template) {
    $this->template = $template;
    return $this;
  }

  /**
   * Get the template that this component is aware of.
   *
   * @return \Drupal\entity_template\Plugin\EntityTemplate\Template\TemplateInterface
   */
  public function getTemplate() : TemplateInterface {
    return $this->template;
  }

  /**
   * Get the context providing template.
   *
   * @return \Drupal\entity_template\Plugin\EntityTemplate\Template\TemplateInterface
   */
  public function getContextProvidingTemplate() : TemplateInterface {
    return $this->getTemplate()->getContextProvidingTemplate();
  }
}
